/* vi: set ts=4 sw=4: */
/* -*- mode: c; c-basic-offset: 4; tab-width: 4 -*- */

#include <stdio.h>
#include <stdlib.h>
#include <ao/ao.h>
#include "augen.h"

int main(void) {
	ao_device *dev;
	ao_sample_format fmt;
	struct ag_buffer *sbuf;
	sample_t *buf16;
	size_t bsz;
	
	ao_initialize();

	fmt.bits = 16;
	fmt.channels = 2;
	fmt.rate = 44100;
	fmt.byte_format = AO_FMT_LITTLE;

	if(!(dev = ao_open_live(ao_default_driver_id(), &fmt, 0))) {
		fputs("Failed to open audio device\n", stderr);
		return EXIT_FAILURE;
	}

	if(!(sbuf = ag_buffer_create(4000))) {
		fputs("le poul\n", stderr);
		return EXIT_FAILURE;
	}

	bsz = ag_buffer_size(4000, 2);
	buf16 = malloc(bsz);

	ag_gen_wave(sbuf, 4000, 440.0, 1.0, AG_WAVE_SIN);
	ag_buffer_clip(buf16, sbuf);

	ao_play(dev, (void*)buf16, bsz);

	free(buf16);
	
	ag_buffer_free(sbuf);
	ao_close(dev);
	ao_shutdown();

	return 0;
}
