/* vi: set ts=4 sw=4: */
/* -*- mode: c; c-basic-offset: 4; tab-width: 4 -*- */

#ifndef AUGEN_AUGEN_H_
#define AUGEN_AUGEN_H_

#include "types.h"

struct ag_buffer {
	wsample_t *data;
	size_t size;
	int samples;
};

enum {
	AG_WAVE_SIN,
	AG_WAVE_SAW,
	AG_WAVE_SQUARE
};

#ifdef __cplusplus
extern "C" {
#endif	/* __cplusplus */

struct ag_buffer *ag_buffer_create(long msec);
void ag_buffer_free(struct ag_buffer *buf);

void ag_buffer_clip(sample_t *dest, struct ag_buffer *buf);
void ag_buffer_norm(sample_t *dest, struct ag_buffer *buf);

size_t ag_buffer_size(long msec, size_t sample_size);
void ag_gen_wave(struct ag_buffer *buf, long msec, float freq, float ampl, int type);

void ag_buffer_clear(struct ag_buffer *buf);
void ag_buffer_add(struct ag_buffer *dest, struct ag_buffer *b1, struct ag_buffer *b2);
int ag_buffer_cat(struct ag_buffer *dest, struct ag_buffer *src);

#ifdef __cplusplus
}
#endif	/* __cplusplus */

#endif	/* AUGEN_AUGEN_H_ */
