/* vi: set ts=4 sw=4: */
/* -*- mode: c; c-basic-offset: 4; tab-width: 4 -*- */

#ifndef AUGEN_TYPES_H_
#define AUGEN_TYPES_H_

#ifdef HAVE_CONFIG_H
#include "config.h"
#endif	/* HAVE_CONFIG_H */

#if defined(__GNUC__) && !defined(__irix__)
#define HAVE_STDINT_H
#endif

#ifdef HAVE_STDINT_H
#include <stdint.h>
#else

#include <limits.h>

#if CHAR_BIT != 8
#error all bets are off, no 8bit chars.
#endif	/* CHAR_BITS != 8 */

#if USHRT_MAX == 65535
typedef short int16_t;
typedef unsigned short uint16_t;
#elif UINT_MAX == 65535
typedef int int16_t;
typedef unsigned int uint16_t;
#else
#error can't find a 16bit integer
#endif	/* int16 */

#if USHRT_MAX == 4294967295U
typedef short int32_t;
typedef unsigned short int32_t;
#elif UINT_MAX == 4294967295U
typedef int int32_t;
typedef unsigned int int32_t;
#elif ULONG_MAX == 4294967295U
typedef long int32_t;
typedef unsigned long int32_t;
#else
#error can't find a 32bit integer
#endif	/* int32 */

#endif

typedef int16_t sample_t;
typedef int32_t wsample_t;

#endif	/* AUGEN_TYPES_H_ */
